<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bussinessuserwithdraw_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bussinessmng/bussinessuserwithdraw";
  import {mapGetters} from "vuex";

  export default {
    props:{
      userInfoId: null
    },
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          editDisplay: false,
          addDisplay: false,
          delBtn: false,
          menu: false,
          dialogClickModal: false,
          column: [
            {
              label: "商户请求号",
              prop: "requestNo",
            },
            {
              label: "提现账号",
              prop: "bankAccountNo",
            },
            {
              label: "到账类型",
              prop: "receiveType",
              type: "select",
              dicData: [
                {
                  label: '实时',
                  value: "REAL_TIME"
                },
                {
                  label: '2小时到账',
                  value: "TWO_HOUR"
                },
                {
                  label: '次日到账',
                  value: "NEXT_DAY"
                }
              ]
            },
            {
              label: "提现金额（元）",
              prop: "orderAmount",
            },
            {
              label: "用户名称",
              prop: "userInfoId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bussiness-user-info/bussinessuserinfo/listUserInfo",
              props:{
                label: "userName",
                value: "id"
              },
            },
            {
              label: "提现状态",
              prop: "withdrawStatus",
              dicData: [
                {
                  label: '待发起',
                  value: 10
                },
                {
                  label: '处理中',
                  value: 11
                },
                {
                  label: '处理中',
                  value: 12
                },
                {
                  label: '处理中',
                  value: 13
                },
                {
                  label: '失败',
                  value: 14
                },
                {
                  label: '成功',
                  value: 15
                },
              ]
            },
            {
              label: "失败原因",
              prop: "failReason",
            },
            {
              label: "是否冲退",
              prop: "isReversed",
              dicData: [
                {
                  label: '是',
                  value: 1
                },
                {
                  label: '否',
                  value: 0
                },
              ]
            },
            {
              label: "采购商订单号",
              prop: "bussinessOrderId",
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussinessuserwithdraw_add, false),
          viewBtn: this.vaildData(this.permission.bussinessuserwithdraw_view, false),
          delBtn: this.vaildData(this.permission.bussinessuserwithdraw_delete, false),
          editBtn: this.vaildData(this.permission.bussinessuserwithdraw_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        if(this.userInfoId != null){
          params['userInfoId'] = this.userInfoId;
        }
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
